Index: LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90	(revision 1795)
@@ -101,7 +101,7 @@
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, fco2_ocn_day
     USE surface_data
+    USE indice_sol_mod
 
     INCLUDE "dimensions.h"
-    INCLUDE "indicesol.h"
     INCLUDE "temps.h"
     INCLUDE "iniprint.h"
@@ -295,6 +295,6 @@
     USE phys_state_var_mod, ONLY : rlon, rlat
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
-    
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "temps.h"
     INCLUDE "iniprint.h"
@@ -424,5 +424,5 @@
 !
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, fco2_ocn_day
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
 
 ! Input arguments
@@ -541,5 +541,5 @@
 !
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
     INCLUDE "dimensions.h"
 
@@ -732,5 +732,5 @@
 !
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
     INCLUDE "dimensions.h"
 
@@ -1026,7 +1026,7 @@
     USE surface_data
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
+    USE indice_sol_mod
 ! Some includes
 !*************************************************************************************
-    INCLUDE "indicesol.h"
     INCLUDE "temps.h"
     INCLUDE "dimensions.h"
Index: LMDZ5/branches/testing/libf/phylmd/cv3_routines.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3_routines.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cv3_routines.F	(revision 1795)
@@ -3561,5 +3561,6 @@
       SUBROUTINE cv3_tracer(nloc,len,ncum,nd,na,
      &                       ment,sigij,da,phi,phi2,d1a,dam,
-     &                       ep,Vprecip,elij,clw,icb,inb)
+     &                       ep,Vprecip,elij,clw,epmlmMm,eplaMm,
+     &                       icb,inb)
         implicit none
 
@@ -3577,4 +3578,5 @@
 	real phi2(nloc,na,na)
 	real d1a(nloc,na),dam(nloc,na)
+	real epmlmMm(nloc,na,na),eplaMm(nloc,na)
 ! variables pour tracer dans precip de l'AA et des mel
 c local variables:
@@ -3595,12 +3597,21 @@
        dam(:,:)=0.
        epm(:,:,:)=0.
-c
-!  fraction deau condensee dans les melanges convertie en precip
+       eplaMm(:,:)=0.
+       epmlmMm(:,:,:)=0.
+       phi(:,:,:)=0.
+       phi2(:,:,:)=0.
+c
+!  fraction deau condensee dans les melanges convertie en precip : epm
+! et eau condensée précipitée dans masse d'air saturé : l_m*dM_m/dzdz.dzdz
         do j=1,na
          do k=1,na
            do i=1,ncum
             if(k.ge.icb(i).and.k.le.inb(i).and.
-     &         j.ge.k.and.j.le.inb(i)) then
-             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/elij(i,k,j)
+!!jyg     &         j.ge.k.and.j.le.inb(i)) then
+!!jyg             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/elij(i,k,j)
+     &         j.gt.k.and.j.le.inb(i)) then
+             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/
+     &                     max(elij(i,k,j),1.e-16)
+!!
              epm(i,j,k)=max(epm(i,j,k),0.0)
             endif
@@ -3608,4 +3619,27 @@
          end do 
         end do 
+
+!
+        do j=1,na
+         do k=1,na
+           do i=1,ncum
+            if(k.ge.icb(i).and.k.le.inb(i)) then
+             eplaMm(i,j)=eplaMm(i,j) + ep(i,j)*clw(i,j)
+     &                  *ment(i,j,k)*(1.-sigij(i,j,k))
+            endif
+           end do 
+         end do 
+        end do
+!
+        do j=1,na
+         do k=1,j-1
+           do i=1,ncum
+            if(k.ge.icb(i).and.k.le.inb(i).and.
+     &         j.le.inb(i)) then
+             epmlmMm(i,j,k)=epm(i,j,k)*elij(i,k,j)*ment(i,k,j)
+            endif
+           end do 
+         end do 
+        end do
 
 !  matrices pour calculer la tendance des concentrations dans cvltr.F90
@@ -3622,7 +3656,4 @@
 
              phi2(i,j,k)=phi(i,j,k)*epm(i,j,k)   
-            else
-             dam(i,j)=0.
-             phi2(i,j,k)=0.
             endif
             end do 
Index: LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F	(revision 1795)
@@ -10,23 +10,21 @@
      :         ,asupmaxmin
 !
-     :         ,da,phi                               !AC!
-     :         ,mp,phi2,d1a,dam,sigij                  !RomP
-     :         ,wdtrainA,wdtrainM,elij,clw           !RomP
-     :         ,evap,ep                              !RomP
+     :          ,da,phi,mp,phi2,d1a,dam,sigij         ! RomP+AC+jyg
+     :          ,clw,elij,evap,ep,epmlmMm,eplaMm      ! RomP
+     :          ,wdtrainA,wdtrainM                    ! RomP
 !
      o         ,iflag1,kbas1,ktop1
-     :         ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
-     :         ,ft1,fq1,fu1,fv1,ftra1
-     :         ,sigd1,Ma1,mip1,Vprecip1,upwd1,dnwd1,dnwd01
-     :         ,qcondc1,wd1,cape1,cin1
-     :         ,tvp1
-     :         ,ftd1,fqd1
-     :         ,Plim11,Plim21,asupmax1,supmax01
-     :         ,asupmaxmin1     
-!
-     o         ,da1,phi1                             !AC!
-     o         ,mp1,phi21,d1a1,dam1,sigij1             !RomP
-     o         ,wdtrainA1,wdtrainM1,elij1,clw1       !RomP
-     o         ,evap1,ep1)                           !RomP
+     o         ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
+     o         ,ft1,fq1,fu1,fv1,ftra1
+     o         ,sigd1,Ma1,mip1,Vprecip1,upwd1,dnwd1,dnwd01
+     o         ,qcondc1,wd1,cape1,cin1
+     o         ,tvp1
+     o         ,ftd1,fqd1
+     o         ,Plim11,Plim21,asupmax1,supmax01
+     o         ,asupmaxmin1     
+!
+     o          ,da1,phi1,mp1,phi21,d1a1,dam1,sigij1  ! RomP+AC+jyg
+     o          ,clw1,elij1,evap1,ep1,epmlmMm1,eplaMm1! RomP
+     o          ,wdtrainA1,wdtrainM1)                 ! RomP
 !
 ***************************************************************
@@ -67,8 +65,9 @@
       real phi2(nloc,nd,nd)                               !RomP
       real d1a(nloc,nd),dam(nloc,nd)                      !RomP
+      real sigij(nloc,nd,nd)                              !RomP
+      real clw(nloc,nd),elij(nloc,nd,nd)                  !RomP
+      real evap(nloc,nd),ep(nloc,nd)                      !RomP
+      real epmlmMm(nloc,nd,nd),eplaMm(nloc,nd)            !RomP+jyg
       real wdtrainA(nloc,nd), wdtrainM(nloc,nd)           !RomP
-      real sigij(nloc,nd,nd)                                !RomP
-      real elij(nloc,nd,nd),clw(nloc,nd)                  !RomP
-      real evap(nloc,nd),ep(nloc,nd)                      !RomP
 !
 c outputs:
@@ -94,12 +93,14 @@
       real phi21(nloc,nd,nd)                              !RomP
       real d1a1(nloc,nd),dam1(nloc,nd)                    !RomP
+      real sigij1(len,nd,nd)                              !RomP
+      real clw1(len,nd),elij1(len,nd,nd)                  !RomP
+      real evap1(len,nd),ep1(len,nd)                      !RomP
+      real epmlmMm1(len,nd,nd),eplaMm1(len,nd)            !RomP+jyg
       real wdtrainA1(len,nd), wdtrainM1(len,nd)           !RomP
-      real sigij1(len,nd,nd)                                !RomP
-      real elij1(len,nd,nd),clw1(len,nd)                  !RomP
-      real evap1(len,nd),ep1(len,nd)                      !RomP
 !
 c
 c local variables:
-      integer i,k,j,k1,k2
+      integer i,k,j
+cc    integer k1,k2
 
         do 2000 i=1,ncum
@@ -147,9 +148,10 @@
             d1a1(idcum(i),k)     = d1a(i,k)               !RomP
             dam1(idcum(i),k)     = dam(i,k)               !RomP
-            wdtrainA1(idcum(i),k)= wdtrainA(i,k)          !RomP
-            wdtrainM1(idcum(i),k)= wdtrainM(i,k)          !RomP
             clw1(idcum(i),k)     = clw(i,k)               !RomP
             evap1(idcum(i),k)    = evap(i,k)              !RomP
             ep1(idcum(i),k)      = ep(i,k)                !RomP
+            eplaMm(idcum(i),k)   = eplaMm(i,k)            !RomP+jyg
+            wdtrainA1(idcum(i),k)= wdtrainA(i,k)          !RomP
+            wdtrainM1(idcum(i),k)= wdtrainM(i,k)          !RomP
 !
  2010    continue
@@ -171,11 +173,12 @@
 
 !AC!
-       do k2=1,nd
-         do k1=1,nd 
+       do j=1,nd
+         do k=1,nd 
           do i=1,ncum
-            phi1(idcum(i),k1,k2)=phi(i,k1,k2)                 !AC!
-            phi21(idcum(i),k1,k2)= phi2(idcum(i),k1,k2)   !RomP
-            sigij1(idcum(i),k1,k2) = sigij(idcum(i),k1,k2)    !RomP
-            elij1(idcum(i),k1,k2)= elij(idcum(i),k1,k2)   !RomP
+            phi1(idcum(i),k,j)   = phi(i,k,j)           !AC!
+            phi21(idcum(i),k,j)  = phi2(i,k,j)          !RomP
+            sigij1(idcum(i),k,j) = sigij(i,k,j)         !RomP
+            elij1(idcum(i),k,j)  = elij(i,k,j)          !RomP
+            epmlmMm(idcum(i),k,j)= epmlmMm(i,k,j)       !RomP+jyg
           end do
          end do
Index: LMDZ5/branches/testing/libf/phylmd/cv_driver.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv_driver.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cv_driver.F	(revision 1795)
@@ -9,7 +9,7 @@
      &                   icb1,inb1,
      &                   delt,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1,
-     &                   da1,phi1,mp1,phi21,d1a1,dam1,sij1,clw1,elij1,
-     &                   evap1,ep1,epmlmMm1,eplaMm1,
-     &                   wdtrainA1,wdtrainM1)
+     &                   da1,phi1,mp1,phi21,d1a1,dam1,sij1,clw1,elij1,  ! RomP
+     &                   evap1,ep1,epmlmMm1,eplaMm1,                    ! RomP 
+     &                   wdtrainA1,wdtrainM1)                           ! RomP
 C
       USE dimphy
@@ -18,4 +18,8 @@
 C.............................START PROLOGUE............................
 C
+!
+! All argument names (except len,nd,ntra,nloc,delt and the flags) have a "1" appended.
+! The "1" is removed for the corresponding compressed (local) variables.
+!
 C PARAMETERS:
 C      Name            Type         Usage            Description
@@ -54,4 +58,22 @@
 C      wd1           Real           Output       downdraft velocity scale for sfc fluxes
 C      cape1         Real           Output       CAPE
+!    
+!      wdtrainA1     Real           Output   precipitation detrained from adiabatic draught;
+!                                                       used in tracer transport (cvltr)
+!      wdtrainM1     Real           Output   precipitation detrained from mixed draughts;
+!                                                       used in tracer transport (cvltr)
+!      da1           Real           Output   used in tracer transport (cvltr)
+!      phi1          Real           Output   used in tracer transport (cvltr)
+!      mp1           Real           Output   used in tracer transport (cvltr)
+!    
+!      phi21         Real           Output   used in tracer transport (cvltr)
+!    
+!      d1a1          Real           Output   used in tracer transport (cvltr)
+!      dam1          Real           Output   used in tracer transport (cvltr)
+!    
+!      evap1         Real           Output
+!      ep1           Real           Output
+!      sij1        Real           Output
+!      elij1         Real           Output
 C
 C S. Bony, Mar 2002:
@@ -119,6 +141,7 @@
       real epmlmMm1(len,nd,nd),eplaMm1(len,nd)
 ! RomP <<<
-
-
+!
+!-------------------------------------------------------------------
+!        Original Prologue by Kerry Emanuel.
 !-------------------------------------------------------------------
 ! --- ARGUMENTS
@@ -291,12 +314,4 @@
       real ments(nloc,klev,klev), qents(nloc,klev,klev)
       real sij(nloc,klev,klev), elij(nloc,klev,klev)
-! RomP >>>
-      real da(nloc,klev),phi(nloc,klev,klev),mp(nloc,klev)
-      real epmlmMm(nloc,klev,klev),eplaMm(nloc,klev)  
-      real phi2(nloc,klev,klev)
-      real d1a(nloc,klev), dam(nloc,klev)
-      real wdtrainA(nloc,klev),wdtrainM(nloc,klev)
-      real sigd(nloc)
-! RomP <<<
       real qp(nloc,klev), up(nloc,klev), vp(nloc,klev)
       real wt(nloc,klev), water(nloc,klev), evap(nloc,klev)
@@ -312,4 +327,13 @@
       real qcondc(nloc,klev)  ! cld
       real wd(nloc)           ! gust
+!
+! RomP >>>
+      real da(nloc,klev),phi(nloc,klev,klev),mp(nloc,klev)
+      real epmlmMm(nloc,klev,klev),eplaMm(nloc,klev)  
+      real phi2(nloc,klev,klev)
+      real d1a(nloc,klev), dam(nloc,klev)
+      real wdtrainA(nloc,klev),wdtrainM(nloc,klev)
+      real sigd(nloc)
+! RomP <<<
 
       nent(:,:)=0
@@ -380,4 +404,21 @@
         enddo
       endif
+
+! RomP >>> 
+       wdtrainA1(:,:)  =0.
+        wdtrainM1(:,:) =0.
+       da1(:,:)        =0.
+       phi1(:,:,:)     =0.
+       epmlmMm1(:,:,:) =0.
+       eplaMm1(:,:)    =0.
+       mp1(:,:)        =0.
+       evap1(:,:)      =0.
+       ep1(:,:)        =0.
+       sij1(:,:,:)     =0.
+       elij1(:,:,:)    =0.
+       phi21(:,:,:)    =0.
+       d1a1(:,:)       =0.
+       dam1(:,:)       =0.
+! RomP <<<
 
 !--------------------------------------------------------------------
@@ -729,3 +770,2 @@
       return
       end
-
Index: LMDZ5/branches/testing/libf/phylmd/cva_driver.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1795)
@@ -22,5 +22,5 @@
      &                   ,lalim_conv, 
      &                   da1,phi1,mp1,phi21,d1a1,dam1,sigij1,clw1,     ! RomP
-     &                   elij1,evap1,ep1,                              ! RomP 
+     &                   elij1,evap1,ep1,epmlmMm1,eplaMm1,             ! RomP 
      &                   wdtrainA1,wdtrainM1)                          ! RomP
 ***************************************************************
@@ -39,4 +39,7 @@
 C.............................START PROLOGUE............................
 C
+!
+! All argument names (except len,nd,ntra,nloc,delt and the flags) have a "1" appended.
+! The "1" is removed for the corresponding compressed variables.
 C PARAMETERS:
 C      Name            Type         Usage            Description
@@ -99,4 +102,33 @@
 C      supmax01      Real           Output
 C      asupmaxmin1   Real           Output
+!
+!      ftd1          Real           Output  Array of temperature tendency due to precipitations (K/s) of dimension ND,
+!                                           defined at same grid levels as T, Q, QS and P.
+!    
+!      fqd1          Real           Output  Array of specific humidity tendencies due to precipitations ((gm/gm)/s)
+!                                           of dimension ND, defined at same grid levels as T, Q, QS and P.
+!    
+!      wdtrainA1     Real           Output   precipitation detrained from adiabatic draught;
+!                                                       used in tracer transport (cvltr)
+!      wdtrainM1     Real           Output   precipitation detrained from mixed draughts;
+!                                                       used in tracer transport (cvltr)
+!      da1           Real           Output   used in tracer transport (cvltr)
+!      phi1          Real           Output   used in tracer transport (cvltr)
+!      mp1           Real           Output   used in tracer transport (cvltr)
+!    
+!      phi21         Real           Output   used in tracer transport (cvltr)
+!    
+!      d1a1          Real           Output   used in tracer transport (cvltr)
+!      dam1          Real           Output   used in tracer transport (cvltr)
+!    
+!      epmlmMm1      Real           Output   used in tracer transport (cvltr)
+!      eplaMm1       Real           Output   used in tracer transport (cvltr)
+!
+!      evap1         Real           Output
+!      ep1           Real           Output
+!      sigij1        Real           Output
+!      elij1         Real           Output
+
+C
 C S. Bony, Mar 2002:
 C 	* Several modules corresponding to different physical processes
@@ -188,14 +220,14 @@
 ! RomP >>> 
       real wdtrainA1(len,nd), wdtrainM1(len,nd)
-      real wdtrainA(nloc,klev),wdtrainM(nloc,klev)
       real da1(len,nd),phi1(len,nd,nd),mp1(len,nd)
-      real da(len,nd),phi(len,nd,nd)
+      real epmlmMm1(len,nd,nd),eplaMm1(len,nd)
       real evap1(len,nd),ep1(len,nd)
       real sigij1(len,nd,nd),elij1(len,nd,nd)
-      real phi2(len,nd,nd)
-      real d1a(len,nd), dam(len,nd)
       real phi21(len,nd,nd)
       real d1a1(len,nd), dam1(len,nd)
 ! RomP <<<
+!
+!-------------------------------------------------------------------
+!        Prolog by Kerry Emanuel.
 !-------------------------------------------------------------------
 ! --- ARGUMENTS
@@ -320,11 +352,4 @@
 !
 !  det:   Array of detrainment mass flux of dimension ND.
-!
-!  ftd:  Array of temperature tendency due to precipitations (K/s) of dimension ND,
-!        defined at same grid levels as T, Q, QS and P.
-!
-!  fqd:  Array of specific humidity tendencies due to precipitations ((gm/gm)/s)
-!        of dimension ND, defined at same grid levels as T, Q, QS and P.
-!
 !-------------------------------------------------------------------
 c
@@ -446,4 +471,13 @@
       real wghti(nloc,nd)
       real hnk(nloc),unk(nloc),vnk(nloc)
+!
+! RomP >>> 
+      real wdtrainA(nloc,klev),wdtrainM(nloc,klev)
+      real da(len,nd),phi(len,nd,nd)
+      real epmlmMm(nloc,klev,klev),eplaMm(nloc,klev)  
+      real phi2(len,nd,nd)
+      real d1a(len,nd), dam(len,nd)
+! RomP <<<
+!
       logical, save :: first=.true.
 c$OMP THREADPRIVATE(first)
@@ -498,45 +532,34 @@
       nword4=len*nd*nd
  
-!      call izilch(iflag1  ,nword1)
-!      call  zilch(iflag1  ,nword1)
-      do i=1,len
-         iflag1(i)=0
-         ktop1(i)=0
-         kbas1(i)=0
-      enddo
-      call  zilch(ft1     ,nword2)
-      call  zilch(fq1     ,nword2)
-      call  zilch(fu1     ,nword2)
-      call  zilch(fv1     ,nword2)
-      call  zilch(ftra1   ,nword3)
-      call  zilch(precip1 ,nword1)
-!      call izilch(kbas1   ,nword1)
-!      call  zilch(kbas1   ,nword1)
-!      call izilch(ktop1   ,nword1)
-!      call  zilch(ktop1   ,nword1)
-      call  zilch(cbmf1   ,nword1)
-      call  zilch(ptop21  ,nword1)
-      sigd1(:)=0.
-      call  zilch(Ma1     ,nword2)
-      call  zilch(mip1    ,nword2)
-!      call  zilch(Vprecip1,nword2)
-      Vprecip1=0.
-      call  zilch(upwd1   ,nword2)
-      call  zilch(dnwd1   ,nword2)
-      call  zilch(dnwd01  ,nword2)
-      call  zilch(qcondc1 ,nword2)
-!test
-!      call  zilch(qcondc ,nword2)
-      call  zilch(wd1     ,nword1)
-      call  zilch(cape1   ,nword1)
-      call  zilch(cin1    ,nword1)
-      call  zilch(tvp1    ,nword2)
-      call  zilch(ftd1    ,nword2)
-      call  zilch(fqd1    ,nword2)
-      call  zilch(Plim11  ,nword1)
-      call  zilch(Plim21  ,nword1)
-      call  zilch(asupmax1,nword2)
-      call  zilch(supmax01,nword1)
-      call  zilch(asupmaxmin1,nword1)
+      iflag1(:)     = 0
+      ktop1(:)      = 0
+      kbas1(:)      = 0
+      ft1(:,:)      = 0.0
+      fq1(:,:)      = 0.0
+      fu1(:,:)      = 0.0
+      fv1(:,:)      = 0.0
+      ftra1(:,:,:)  = 0.
+      precip1(:)    = 0.
+      cbmf1(:)      = 0.
+      ptop21(:)     = 0.
+      sigd1(:)      = 0.
+      Ma1(:,:)      = 0.
+      mip1(:,:)     = 0.
+      Vprecip1(:,:) = 0.
+      upwd1   (:,:) = 0.
+      dnwd1   (:,:) = 0.
+      dnwd01  (:,:) = 0.
+      qcondc1 (:,:) = 0.
+      wd1     (:)   = 0.
+      cape1   (:)   = 0.
+      cin1    (:)   = 0.
+      tvp1    (:,:) = 0.
+      ftd1    (:,:) = 0.
+      fqd1    (:,:) = 0.
+      Plim11  (:)   = 0.
+      Plim21  (:)   = 0.
+      asupmax1(:,:) = 0.
+      supmax01(:)   = 0.
+      asupmaxmin1(:)= 0.
 c
       DO il = 1,len
@@ -552,4 +575,20 @@
       endif
   
+! RomP >>> 
+       wdtrainA1(:,:)  = 0.
+       wdtrainM1(:,:)  = 0.
+       da1(:,:)        = 0.
+       phi1(:,:,:)     = 0.
+       epmlmMm1(:,:,:) = 0.
+       eplaMm1(:,:)    = 0.
+       mp1(:,:)        = 0.
+       evap1(:,:)      = 0.
+       ep1(:,:)        = 0.
+       sigij1(:,:,:)   = 0.
+       elij1(:,:,:)    = 0.
+       phi21(:,:,:)    = 0.
+       d1a1(:,:)       = 0.
+       dam1(:,:)       = 0.
+! RomP <<<
 !---------------------------------------------------------------------
 ! --- INITIALIZE LOCAL ARRAYS AND PARAMETERS
@@ -941,5 +980,6 @@
        CALL cv3_tracer(nloc,len,ncum,nd,nd,
      :                  ment,sigij,da,phi,phi2,d1a,dam,
-     :                  ep,Vprecip,elij,clw,icb,inb)
+     :                  ep,Vprecip,elij,clw,epmlmMm,eplaMm,
+     :                  icb,inb)
 !RomP <<<
       endif
@@ -964,6 +1004,6 @@
      :          ,asupmaxmin
      :          ,da,phi,mp,phi2,d1a,dam,sigij         ! RomP
-     :          ,wdtrainA,wdtrainM,elij,clw           ! RomP
-     :          ,evap,ep                              ! RomP
+     :          ,clw,elij,evap,ep,epmlmMm,eplaMm      ! RomP
+     :          ,wdtrainA,wdtrainM                    ! RomP
      o          ,iflag1,kbas1,ktop1
      o          ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
@@ -976,6 +1016,6 @@
      o          ,asupmaxmin1
      o          ,da1,phi1,mp1,phi21,d1a1,dam1,sigij1  ! RomP
-     o          ,wdtrainA1,wdtrainM1,elij1,clw1       ! RomP
-     o          ,evap1,ep1)                           ! RomP
+     o          ,clw1,elij1,evap1,ep1,epmlmMm1,eplaMm1! RomP
+     o          ,wdtrainA1,wdtrainM1)                 ! RomP
       endif
 
Index: LMDZ5/branches/testing/libf/phylmd/cvltr.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cvltr.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cvltr.F90	(revision 1795)
@@ -121,7 +121,10 @@
    coefcoli         = 0.
 
+!$OMP MASTER
   call getin('ccntrAA_coef',ccntrAA_coef)
   call getin('ccntrENV_coef',ccntrENV_coef)
   call getin('coefcoli',coefcoli)
+!$OMP END MASTER
+!$OMP BARRIER
   print*,'cvltr coef lessivage convectif', ccntrAA_coef,ccntrENV_coef,coefcoli
 
Index: LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90	(revision 1795)
+++ LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90	(revision 1795)
@@ -0,0 +1,171 @@
+subroutine ener_conserv(klon,klev,pdtphys, &
+ &    puo,pvo,pto,pqo,pun,pvn,ptn,pqn,dtke,masse,exner,d_t_ec)
+
+!=============================================================
+! Energy conservation
+! Based on the TKE equation
+! The M2 and N2 terms at the origin of TKE production are
+! concerted into heating in the d_t_ec term
+! Option 1 is the standard
+!        101 is for M2 term only
+!        101 for N2 term only
+!         -1 is a previours treatment for kinetic energy only
+!  FH (hourdin@lmd.jussieu.fr), 2013/04/25
+!=============================================================
+
+!=============================================================
+! Declarations
+!=============================================================
+
+! From module
+USE phys_local_var_mod, ONLY : d_u_vdf,d_v_vdf,d_t_vdf,d_u_ajs,d_v_ajs,d_t_ajs,d_u_con,d_v_con,d_t_con,d_t_diss
+USE phys_output_var_mod, ONLY : bils_ec,bils_tke,bils_kinetic,bils_enthalp,bils_latent,bils_diss
+
+IMPLICIT none
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "clesphys.h"
+#include "compbl.h"
+
+! Arguments
+INTEGER, INTENT(IN) :: klon,klev
+REAL, INTENT(IN) :: pdtphys
+REAL, DIMENSION(klon,klev),INTENT(IN) :: puo,pvo,pto,pqo
+REAL, DIMENSION(klon,klev),INTENT(IN) :: pun,pvn,ptn,pqn
+REAL, DIMENSION(klon,klev),INTENT(IN) :: masse,exner
+REAL, DIMENSION(klon,klev+1),INTENT(IN) :: dtke
+REAL, DIMENSION(klon,klev),INTENT(OUT) :: d_t_ec
+      integer k,i
+
+! Local
+REAL, DIMENSION(klon,klev+1) :: fluxu,fluxv,fluxt
+REAL, DIMENSION(klon,klev+1) :: dddu,dddv,dddt
+REAL, DIMENSION(klon,klev) :: d_u,d_v,d_t,zv,zu
+REAL ZRCPD
+
+character*80 abort_message
+character*20 :: modname
+
+
+modname='ener_conser'
+d_t_ec(:,:)=0.
+
+IF (iflag_ener_conserv==-1) THEN
+!+jld ec_conser
+   DO k = 1, klev
+   DO i = 1, klon
+      ZRCPD = RCPD*(1.0+RVTMP2*pqn(i,k))
+      d_t_ec(i,k)=0.5/ZRCPD &
+ &      *(puo(i,k)**2+pvo(i,k)**2-pun(i,k)**2-pvn(i,k)**2)
+      ENDDO
+      ENDDO
+!-jld ec_conser
+
+
+
+ELSEIF (iflag_ener_conserv>=1) THEN
+
+   IF (iflag_ener_conserv<=2) THEN
+!     print*,'ener_conserv pbl=',iflag_pbl
+      IF (iflag_pbl>=20 .AND. iflag_pbl<=27) THEN !d_t_diss accounts for conserv
+         d_t(:,:)=d_t_ajs(:,:)   ! d_t_ajs = adjust + thermals
+         d_u(:,:)=d_u_ajs(:,:)+d_u_con(:,:)
+         d_v(:,:)=d_v_ajs(:,:)+d_v_con(:,:)
+      ELSE
+         d_t(:,:)=d_t_vdf(:,:)+d_t_ajs(:,:)   ! d_t_ajs = adjust + thermals
+         d_u(:,:)=d_u_vdf(:,:)+d_u_ajs(:,:)+d_u_con(:,:)
+         d_v(:,:)=d_v_vdf(:,:)+d_v_ajs(:,:)+d_v_con(:,:)
+      ENDIF
+   ELSEIF (iflag_ener_conserv==101) THEN
+      d_t(:,:)=0.
+      d_u(:,:)=d_u_vdf(:,:)+d_u_ajs(:,:)+d_u_con(:,:)
+      d_v(:,:)=d_v_vdf(:,:)+d_v_ajs(:,:)+d_v_con(:,:)
+   ELSEIF (iflag_ener_conserv==110) THEN
+      d_t(:,:)=d_t_vdf(:,:)+d_t_ajs(:,:)
+      d_u(:,:)=0.
+      d_v(:,:)=0.
+   ELSE
+      abort_message = 'iflag_ener_conserv non prevu'
+      CALL abort_gcm (modname,abort_message,1)
+   ENDIF
+
+!----------------------------------------------------------------------------
+! Two options wether we consider time integration in the energy conservation
+!----------------------------------------------------------------------------
+
+   if (iflag_ener_conserv==2) then
+      zu(:,:)=puo(:,:)
+      zv(:,:)=pvo(:,:)
+   else
+      IF (iflag_pbl>=20 .AND. iflag_pbl<=27) THEN
+         zu(:,:)=puo(:,:)+d_u_vdf(:,:)+0.5*d_u(:,:)
+         zv(:,:)=pvo(:,:)+d_v_vdf(:,:)+0.5*d_v(:,:)
+      ELSE
+         zu(:,:)=puo(:,:)+0.5*d_u(:,:)
+         zv(:,:)=pvo(:,:)+0.5*d_v(:,:)
+      ENDIF
+   endif
+
+   fluxu(:,klev+1)=0.
+   fluxv(:,klev+1)=0.
+   fluxt(:,klev+1)=0.
+
+   do k=klev,1,-1
+      fluxu(:,k)=fluxu(:,k+1)+masse(:,k)*d_u(:,k)
+      fluxv(:,k)=fluxv(:,k+1)+masse(:,k)*d_v(:,k)
+      fluxt(:,k)=fluxt(:,k+1)+masse(:,k)*d_t(:,k)/exner(:,k)
+   enddo
+
+   dddu(:,1)=2*zu(:,1)*fluxu(:,1)
+   dddv(:,1)=2*zv(:,1)*fluxv(:,1)
+   dddt(:,1)=(exner(:,1)-1.)*fluxt(:,1)
+
+   do k=2,klev
+      dddu(:,k)=(zu(:,k)-zu(:,k-1))*fluxu(:,k)
+      dddv(:,k)=(zv(:,k)-zv(:,k-1))*fluxv(:,k)
+      dddt(:,k)=(exner(:,k)-exner(:,k-1))*fluxt(:,k)
+   enddo
+   dddu(:,klev+1)=0.
+   dddv(:,klev+1)=0.
+   dddt(:,klev+1)=0.
+
+   do k=1,klev
+      d_t_ec(:,k)=-(dddu(:,k)+dddu(:,k+1)+dddv(:,k)+dddv(:,k+1) &
+   &  +rcpd*(dddt(:,k)+dddt(:,k+1)))/(2.*rcpd*masse(:,k))
+   enddo
+! d_t_ec=0.
+
+ENDIF
+
+!================================================================
+!  Computation of integrated enthalpie and kinetic energy variation
+!  FH (hourdin@lmd.jussieu.fr), 2013/04/25
+!================================================================
+
+      bils_ec(:)=0.
+      bils_tke(:)=0.
+      bils_diss(:)=0.
+      bils_kinetic(:)=0.
+      bils_enthalp(:)=0.
+      bils_latent(:)=0.
+      DO k=1,klev
+        bils_ec(:)=bils_ec(:)-d_t_ec(:,k)*masse(:,k)
+        bils_tke(:)=bils_tke(:)+0.5*(dtke(:,k)+dtke(:,k+1))*masse(:,k)
+        bils_diss(:)=bils_diss(:)-d_t_diss(:,k)*masse(:,k)
+        bils_kinetic(:)=bils_kinetic(:)+masse(:,k)* &
+     &           (pun(:,k)*pun(:,k)+pvn(:,k)*pvn(:,k) &
+     &            -puo(:,k)*puo(:,k)-pvo(:,k)*pvo(:,k))
+        bils_enthalp(:)= &
+     &  bils_enthalp(:)+masse(:,k)*(ptn(:,k)-pto(:,k)+d_t_ec(:,k))
+        bils_latent(:)=bils_latent(:)+masse(:,k)* &
+     &             (pqn(:,k)-pqo(:,k))
+      ENDDO
+      bils_ec(:)=rcpd*bils_ec(:)/pdtphys
+      bils_tke(:)=bils_tke(:)/pdtphys
+      bils_diss(:)=rcpd*bils_diss(:)/pdtphys
+      bils_kinetic(:)= 0.5*bils_kinetic(:)/pdtphys
+      bils_enthalp(:)=rcpd*bils_enthalp(:)/pdtphys
+      bils_latent(:)=rlvtt*bils_latent(:)/pdtphys
+RETURN
+
+END
Index: LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 1795)
@@ -24,8 +24,9 @@
   USE conf_phys_m,            ONLY: conf_phys
 ! For parameterization of ozone chemistry:
-  use regr_lat_time_coefoz_m, only: regr_lat_time_coefoz
-  use press_coefoz_m, only: press_coefoz
-  use regr_pr_o3_m, only: regr_pr_o3
+  USE regr_lat_time_coefoz_m, only: regr_lat_time_coefoz
+  USE press_coefoz_m, only: press_coefoz
+  USE regr_pr_o3_m, only: regr_pr_o3
   USE netcdf, ONLY : NF90_OPEN, NF90_NOWRITE, NF90_CLOSE, NF90_NOERR
+  USE indice_sol_mod
 #endif
   IMPLICIT NONE
@@ -47,5 +48,4 @@
 #include "comvert.h"
 #include "comconst.h"
-#include "indicesol.h"
 #include "dimsoil.h"
 #include "temps.h"
@@ -101,4 +101,5 @@
   LOGICAL :: ok_LES, ok_ade, ok_aie, ok_cdnc, aerosol_couple, new_aod, callstats
   INTEGER :: iflag_radia, flag_aerosol
+  LOGICAL :: flag_aerosol_strat
   REAL    :: bl95_b0, bl95_b1, fact_cldcon, facttemps, ratqsbas, ratqshaut
   REAL    :: tau_ratqs
@@ -137,5 +138,5 @@
                    iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs,            &
                    ok_ade, ok_aie, ok_cdnc, aerosol_couple,             &
-                   flag_aerosol, new_aod,                               &
+                   flag_aerosol, flag_aerosol_strat, new_aod,           &
                    bl95_b0, bl95_b1,                                    &
                    read_climoz,                                         &
Index: LMDZ5/branches/testing/libf/phylmd/fonte_neige_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/fonte_neige_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/fonte_neige_mod.F90	(revision 1795)
@@ -9,4 +9,5 @@
 !****************************************************************************************
   USE dimphy, ONLY : klon
+  USE indice_sol_mod
 
   IMPLICIT NONE
@@ -44,5 +45,4 @@
 ! restart file. The other variables are initialized to zero.
 !
-    INCLUDE "indicesol.h"
 !****************************************************************************************
 ! Input argument
@@ -120,4 +120,6 @@
        tsurf, precip_rain, precip_snow, &
        snow, qsol, tsurf_new, evap)
+
+  USE indice_sol_mod
         
 ! Routine de traitement de la fonte de la neige dans le cas du traitement
@@ -139,5 +141,4 @@
 !   evap
 !
-  INCLUDE "indicesol.h"
   INCLUDE "dimensions.h"
   INCLUDE "YOETHF.h"
@@ -315,11 +316,14 @@
        fqfonte_out, ffonte_out)
 
+
+
 ! Cumulate ffonte, fqfonte and fqcalving respectively for
 ! all type of surfaces according to their fraction.
 !
 ! This routine is called from physiq.F before histwrite.
-
-    INCLUDE "indicesol.h"
-!****************************************************************************************
+!****************************************************************************************
+
+  USE indice_sol_mod
+
     REAL, DIMENSION(klon,nbsrf), INTENT(IN) :: pctsrf
 
